



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>java设计模式--观察者模式(Observer)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">java设计模式--观察者模式(Observer)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-11 17:26:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<a href="http://www.cnblogs.com/xinhuaxuan/p/3488207.html" rel="external nofollow noreferrer">java设计模式--观察者模式(Observer)</a></div>
<div>
<p>java设计模式--观察者模式(Observer)</p>
<p>观察者模式的定义:<br /><br />
定义对象间的一种一对多的依赖关系。当一个对象的状态发生改变时，所有依赖于它的对象<br /><br />
都得到通知并被自动更新。</p>
<p>认识观察者模式:<br /><br />
1.目标和观察者之间的关系:<br /><br />
按照模式的定义,目标和观察者之间是典型的一对多的关系。<br /><br />
但是要注意，如果观察者只有一个，也是可以的，这样就变相的实现了目标和观察者之间<br /><br />
一对一的关系。</p>
<p>2.观察者模式中有四种对象：<br /><br />
Subject(目标对象),<br /><br />
Observer(定义观察者接口),<br /><br />
ConcreteSubject(具体的目标实现对象),<br /><br />
ConcreteObserver(观察者的具体实现对象)</p>
<p>一个目标可以有任意多个观察者对象，一旦目标的状态发生了改变，所有注册的观察者都会等到通知，<br /><br />
然后各个观察者会对通知作出相应的响应，执行相应的业务功能处理，并使自己的状态和目标的状态保存一致。</p>
<p>Subject:目标对象接口，提供如下功能：<br /><br />
a.一个目标可以被多个观察者观察<br /><br />
b.目标提供对观察者注册和退订的维护<br /><br />
c.当目标的状态发生变化时,目标负责通知所有注册的，有效的观察者</p>
<p>Observer:观察者的接口，提供目标通知时对应的更新方法，这个方法进行相应的业务处理，可以在这个方法<br /><br />
里面回调目标对象，以获取目标对象的数据。</p>
<p>ConcreteSubject：具体的目标实现对象，用来维护目标状态，当目标对象的状态发生改变时，通知<br /><br />
所有注册的、有效的观察者，让观察者执行相应的处理。</p>
<p>ConcreteObserver：观察者的具体实现对象，用来接收目标的通知，并进行相应的后续处理，比如更新<br /><br />
自身的状态以保持和目标的相应状态一致。</p>
<p>举例：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums">import java.util.ArrayList;<br />
import java.util.List;

/**<br />
 * 功能:<br />
 *         目标对象,作为被观察者,它知道观察它的观察者,并提供注册和删除观察者的接口<br />
 * @author Administrator<br />
 *<br />
 */<br />
public class Subject<br />
{<br />
    //用来保存注册的观察者对象,也就是报纸的订阅者<br />
    private List&lt;Observer&gt; readers = new ArrayList&lt;Observer&gt;();

    /**<br />
     * 功能:<br />
     *         注册观察者对象（报纸的读者需要向报社订阅,先要注册）<br />
     * @param observer 观察者对象<br />
     */<br />
    public void attach(Observer reader)<br />
    {<br />
        readers.add(reader);<br />
    }

    /**<br />
     * 功能:<br />
     *         删除观察者对象（报纸的读者可以取消订阅）<br />
     * @param observer<br />
     */<br />
    public void detach(Observer reader)<br />
    {<br />
        readers.remove(reader);<br />
    }

    /**<br />
     * 功能:<br />
     *         通知所有的观察者<br />
     *         （当有报纸出版后，就要主动的送到读者手中，相当于通知读者）<br />
     */<br />
    protected void notifyAllObservers()<br />
    {<br />
        for(Observer reader : readers)<br />
        {<br />
            reader.update(this);<br />
        }<br />
    }<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums">/**<br />
 * 功能:<br />
 *         具体的目标对象,负责把有关状态存入到相应的观察者对象<br />
 *         并在自己状态发生改变时,通知各个观察者<br />
 *         （报纸对象）<br />
 * @author Administrator<br />
 *<br />
 */<br />
public class NewPaper extends Subject<br />
{<br />
    //报纸的具体内容<br />
    private String content;

    /**<br />
     * 功能:<br />
     *         获取报纸的具体内容<br />
     * @return<br />
     */<br />
    public String getContent()<br />
    {<br />
        return content;<br />
    }

    /**<br />
     * 功能:<br />
     *         设置报纸的具体内容，相当于出版报纸<br />
     * @param content<br />
     */<br />
    public void setContent(String content)<br />
    {<br />
        this.content = content;

        //通知所有注册的读者<br />
        this.notifyAllObservers();<br />
    }<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums">/**<br />
 * 功能:<br />
 *         观察者接口,定义一个更新的接口给那些在目标发生改变的时候被通知的对象<br />
 *         （报纸的读者）<br />
 * @author Administrator<br />
 *<br />
 */<br />
public interface Observer<br />
{<br />
    /**<br />
     * 功能:<br />
     *         更新的接口<br />
     * @param subject 传入目标对象,方便获取相应的目标对象的状态<br />
     */<br />
    public void update(Subject subject);<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums">/**<br />
 * 功能:<br />
 *         具体的观察者对象,实现更新的方法,使自身的状态和目标的状态保存一致<br />
 *         （真正的读者）<br />
 * @author Administrator<br />
 *<br />
 */<br />
public class Reader implements Observer<br />
{<br />
    //读者的姓名<br />
    private String name;

    @Override<br />
    public void update(Subject subject)<br />
    {<br />
        //这里采用拉的方式<br />
        System.out.println(name &#043; &quot;收到报纸，内容为: &quot;&#043; ((NewPaper)subject).getContent());<br />
    }

    public String getName()<br />
    {<br />
        return name;<br />
    }

    public void setName(String name)<br />
    {<br />
        this.name = name;<br />
    }<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums">public class Client<br />
{<br />
    public static void main(String[] args)<br />
    {<br />
        //创建一个报纸，作为被观察者<br />
        NewPaper subject = new NewPaper();

        //创建阅读者,也就是观察者<br />
        Reader reader1 = new Reader();<br />
        reader1.setName(&quot;罗纳尔多&quot;);

        Reader reader2 = new Reader();<br />
        reader2.setName(&quot;贝克汉姆&quot;);

        //注册观察者<br />
        subject.attach(reader1);<br />
        subject.attach(reader2);

        subject.setContent(&quot;世界杯要开始了哦.....&quot;);<br />
    }<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<p>对上面的模式进行讲解：<br /><br />
一、目标和观察者之间的关系<br /><br />
按照模式的定义，目标和观察者之间是典型的一对多的关系。<br /><br />
但是，观察者也可以只有一个，这样就实现了目标和观察者之间一对一的关系。</p>
<p>同样，一个观察者可以观察多个目标。</p>
<p>观察者模式中的: 推模型和拉模型</p>
<p>推模型：<br /><br />
目标对象主动向观察者推送目标的详细信息，不管观察者是否需要，推送的信息通常是<br /><br />
目标对象的全部或部分数据</p>
<p>拉模型：<br /><br />
目标对象在通知观察者的时候，只传递少量信息。如果观察者需要更具体的信息，<br /><br />
由观察者主动到目标对象中获取，相当于观察者从目标对象中拉数据。</p>
<p>将上面的代码通过推模型进行实现：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums">import java.util.ArrayList;<br />
import java.util.List;

/**<br />
 * 功能:<br />
 *         目标对象，作为被观察者，使用推模型<br />
 * @author Administrator<br />
 *<br />
 */<br />
public class Subject<br />
{<br />
    //用来保存注册的观察者对象（报纸订阅者）<br />
    private List&lt;Observer&gt; readers = new ArrayList&lt;Observer&gt;();

    /**<br />
     * 功能:<br />
     *         注册观察者对象（报纸的读者需要向报社订阅,先要注册）<br />
     * @param observer 观察者对象<br />
     */<br />
    public void attach(Observer reader)<br />
    {<br />
        readers.add(reader);<br />
    }

    /**<br />
     * 功能:<br />
     *         删除观察者对象（报纸的读者可以取消订阅）<br />
     * @param observer<br />
     */<br />
    public void detach(Observer reader)<br />
    {<br />
        readers.remove(reader);<br />
    }

    /**<br />
     * 功能:<br />
     *         通知所有的观察者<br />
     *         （当有报纸出版后，就要主动的送到读者手中，相当于通知读者）<br />
     */<br />
    protected void notifyAllObservers(String content)<br />
    {<br />
        for(Observer reader : readers)<br />
        {<br />
            reader.update(content);<br />
        }<br />
    }<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums">public class NewsPaper extends Subject<br />
{<br />
    private String content;

    public String getContent()<br />
    {<br />
        return content;<br />
    }

    public void setContent(String content)<br />
    {<br />
        this.content = content;<br />
        //通知所有注册的观察者(读者)<br />
        this.notifyAllObservers(content);<br />
    }<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums">/**<br />
 * 功能:<br />
 *         观察者（报纸的读者）<br />
 * @author Administrator<br />
 *<br />
 */<br />
public interface Observer<br />
{<br />
    /**<br />
     * 功能:<br />
     *         被通知的方法,直接把报纸的内容推送过来<br />
     * @param content<br />
     */<br />
    public void update(String content);<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums">public class Reader implements Observer<br />
{<br />
    //读者的姓名<br />
    private String name;

    @Override<br />
    public void update(String content)<br />
    {<br />
        //这里采用推的方式<br />
        System.out.println(name &#043; &quot;收到报纸了，内容是:&quot; &#043; content);<br />
    }

    public String getName()<br />
    {<br />
        return name;<br />
    }

    public void setName(String name)<br />
    {<br />
        this.name = name;<br />
    }<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums">public class Client<br />
{<br />
    public static void main(String[] args)<br />
    {<br />
        //创建一个报纸，作为被观察者<br />
        NewsPaper subject = new NewsPaper();

        //创建阅读者,也就是观察者<br />
        Reader reader1 = new Reader();<br />
        reader1.setName(&quot;罗纳尔多&quot;);

        Reader reader2 = new Reader();<br />
        reader2.setName(&quot;贝克汉姆&quot;);

        //注册观察者<br />
        subject.attach(reader1);<br />
        subject.attach(reader2);

        subject.setContent(&quot;世界杯要开始了哦.....&quot;);<br />
    }<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums">两种模型的比较：

（1）推模型是假定目标对象知道观察者需要的数据；而拉模型是目标对象不知道观察者具体<br />
需要什么数据，没有办法的情况下，把自身传给观察者，让观察者自己去按需取&#20540;。<br />
（2）推模型可能会使得观察者对象难以复用，因为观察者定义的update方法是按需而定义的，<br />
可能无法兼顾没有考虑到的使用情况。这就意味着出现新情况的时候，就可能需要提供新的update方法，<br />
或者干脆重新实现观察者。

java中的观察者

在java.util包里面有一个类Observable,实现了大部分目标的功能。<br />
java.util包里面有一个类Observer，其中定义了update的方法，就是观察者的接口</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums">import java.util.Observable;

public class NewsPaper extends Observable<br />
{<br />
    //报纸的具体内容<br />
    private String content;

    /**<br />
     * 功能:<br />
     *         获取报纸的具体内容<br />
     * @return<br />
     */<br />
    public String getContent()<br />
    {<br />
        return content;<br />
    }

    /**<br />
     * 功能:<br />
     *         设置报纸的具体内容,相当于出版报纸<br />
     * @param content<br />
     */<br />
    public void setContent(String content)<br />
    {<br />
        this.content = content;

        //通知观察者<br />
        this.setChanged();<br />
        this.notifyObservers(this.content);//采用推的方法

    }<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums">import java.util.Observable;<br />
import java.util.Observer;

/**<br />
 * 功能:<br />
 *         观察者（读者）<br />
 * @author Administrator<br />
 *<br />
 */<br />
public class Reader implements Observer<br />
{<br />
    private String name;

    public String getName()<br />
    {<br />
        return name;<br />
    }

    public void setName(String name)<br />
    {<br />
        this.name = name;<br />
    }

    @Override<br />
    public void update(Observable arg0, Object obj)<br />
    {<br />
        System.out.println(name &#043; &quot;收到报纸了，内容为:&quot;&#043;obj);<br />
    }<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums">public class Client<br />
{<br />
    public static void main(String[] args)<br />
    {<br />
        //创建一个报纸，作为被观察者<br />
        NewsPaper subject = new NewsPaper();

        //创建阅读者，也就是观察者<br />
        Reader reader1 = new Reader();<br />
        reader1.setName(&quot;罗纳尔多&quot;);

        Reader reader2 = new Reader();<br />
        reader2.setName(&quot;贝克汉姆&quot;);

        //注册阅读者<br />
        subject.addObserver(reader1);<br />
        subject.addObserver(reader2);

        //出版报纸<br />
        subject.setContent(&quot;世界杯要开始了咯&quot;);<br />
    }<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<p>观察者模式的本质：触发联动</p>
<p>当修改目标对象的状态的时候，就会触发相应的通知，然后会循环的调用所有注册的观察者对象<br /><br />
的相应方法，其实就相当于联动调用这些观察者的方法。</p>
<p>这个联动还是动态的，可以通过注册和取消注册来控制观察者，因而可以可以在程序运行期间，<br /><br />
通过动态的控制观察者，来变相地实现添加和删除某些功能处理，这些功能就是观察者在update的<br /><br />
时候执行的功能。</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqveo319.html">网格弹簧质点系统模拟（Spring-Mass System by Fast Method）附源码</a>
		</li>
						<li><a href="https://www.batexi.com/a/495onlz8.html">Mac 安装终端软件</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8epzdx9.html">Vue&period;2&period;0&period;5-生产环境部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xrd3m8.html">shell 加减乘除</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmjez69.html">POJ 3691 AC自动机上的dp</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1nvzk8.html">Oracle笔记 九、PL&sol;SQL 游标的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j067p0q.html">Introduction to object</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvlolxq.html">Sql Server导出表结构Excel</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmnrn09.html">python基础学习笔记1</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdnl0y9.html">cairo graphics&period;org</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpdknzq.html">JavaScript DOM节点操作总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp245j9.html">初学Python（九）&mdash;&mdash;函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zwrjj9.html">【learning】&lbrack;待完善&rsqb;关于辛普森公式的一点想法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkj7ej8.html">Jenkins&colon; Can&amp;&num;39&semi;t connect to Docker daemon解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/950l40m8.html">031718-js变量、数据类型、运算符</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj05369.html">HDFS详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o113wpq.html">Spark基础-scala学习（二、面向对象）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gjnveq.html">shiro 单点登录原理 实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy3drmq.html">卡通渲染Shader</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkv13n8.html">instsrv&period;exe srvany&period;exe启动服务</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93y1z508.html">XMLTABLE</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo70j3q.html">&lbrack;python&rsqb;标准库json格式化工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjy3rl8.html">Java进阶&lpar;三十七&rpar;java 自动装箱与拆箱</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j1rrv8.html">log4j 日志限制大小　拆分成30个　不按日期分日志　按大小拆分　按日期产生</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jld1x8.html">&lpar;NO&period;00003&rpar;iOS游戏简单的机器人投射游戏成形记&lpar;十四&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjz1k38.html">MinerHtmlThread&period;java 爬取页面线程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjmd7y8.html">《java入门第一季》正则表达式小案例</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp4pzvq.html">python调用数据库并查询</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpgp4j9.html">AngularJS进阶&lpar;三十三&rpar;书海拾贝之简介AngularJS中使用factory和service的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zyzk19.html">Android StringEntity&lpar;&rpar; 和 UrlEncodedFormEntity&lpar;&rpar; 的区别</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
